#include <basetsd.h>
#include "bitcount.h"


char bitcount_table[0x10000];


/*
 * Return the number of bits which are set in a 32-bit integer.
 * Slower than a table-based bitcount if many bits are set.
 * Only used to make the table for the table-based bitcount
 * on initialization.
 */
int recbitcount(unsigned int n)
{
	int r;

	r = 0;
	while (n) {
		n = n & (n - 1);
		++r;
	}
	return r;
}


void init_bitcount()
{
	unsigned int i;

	for (i = 0; i < 0x10000; ++i)
		bitcount_table[i] = recbitcount(i);
}


#if !INLINE_BITCOUNT


int bitcount(unsigned int n)
{
	return(bitcount_table[n & 0x0000FFFF] + bitcount_table[n >> 16]);
}

int bitcount64(unsigned long long n)
{
	return(bitcount((unsigned int)(n & 0xffffffff)) + bitcount((unsigned int)(n >> 32) & 0xffffffff));
}

#endif
