#define INLINE_BITCOUNT 1

void init_bitcount();


#if INLINE_BITCOUNT

extern char bitcount_table[0x10000];



__forceinline int bitcount(unsigned int n)
{
	return(bitcount_table[n & 0x0000FFFF] + bitcount_table[n >> 16]);
}


__forceinline int bitcount64(unsigned long long n)
{
	return(bitcount((unsigned int)(n & 0xffffffff)) + bitcount((unsigned int)(n >> 32) & 0xffffffff));
}



#else
int bitcount(unsigned int n);
int bitcount64(UINT64 n);
#endif

